<!DOCTYPE html>
<html lang="en">
{% load static %}
{% load pages_extras %}
<head>
	<meta charset="utf-8">
	<!--  This file has been downloaded from bootdey.com @bootdey on twitter -->
	<!--  All snippets are MIT license http://bootdey.com/license -->
	<title>support tickets - Bootdey.com</title>
	<meta name="viewport" content="width=device-width, initial-scale=1">
	<script src="https://code.jquery.com/jquery-1.10.2.min.js"></script>
	<link href="https://netdna.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css" rel="stylesheet">
	<link href="{% static 'css/custom.css' %}" rel="stylesheet">
	<script src="https://netdna.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js"></script>
</head>

<body>
	<link href="https://maxcdn.bootstrapcdn.com/font-awesome/4.3.0/css/font-awesome.min.css" rel="stylesheet">
	<div class="container">
		<section class="content">
			<div class="row">
				<!-- BEGIN NAV TICKET -->
				<div class="col-md-3">
					<div class="grid support">
						<div class="grid-body">
							<a href="{% url 'index' %}" class="logo d-flex align-items-center">
								<img src="{% static 'img/logo.png' %}" alt="">
								<span>Eticket</span>
							</a>
							<hr>
							{% if perms.tickets.can_see_other_ticket %}
								<ul>
									<li class="active"><a href="#">Todos los tickets<span class="pull-right">{{ ticket_list.count }}</span></a>
									</li>
									{% get_my_ticket_count request.user as ticket_count%}
									<li><a href="#">Creados por ti<span class="pull-right">{{ ticket_count }}</span></a></li>
									<li><a href="#">Mencionándote<span class="pull-right">18</span></a></li>
								</ul>

								<hr>
							{% endif %}
							<p><strong>Categorías</strong></p>
							<ul class="support-label">
								{% get_all_categories ticket_list as categories%}
								{% for category in categories %}
									<li><a href="{% url 'user_ticket' %}?
										{% if request.GET.last_status %}
											last_status={{ request.GET.last_status }}&
										{% endif %}
										category={{ category.category__name }}"><span class="bg-blue">&nbsp;</span>&nbsp;&nbsp;&nbsp;{{ category.category__name }}<span
										class="pull-right">{{ category.total }}</span></a></li>
								{% endfor %}
							</ul>
						</div>
					</div>
				</div>
				<!-- END NAV TICKET -->
				<!-- BEGIN TICKET -->
				<div class="col-md-9">
					<div class="grid support-content">
						<div class="grid-body">
							<h2>Tickets</h2>
							<a href="{% url 'logout' %}"> <i class="fa fa-sign-out" aria-hidden="true"></i> <strong>Logout</strong></a>
							<div class="row pull-right">
								<div class="input-group">
									<div class="form-outline">
										<input type="search" id="form1" placeholder="Asunto...? "/>
										<button type="button" class="btn btn-primary">
											<i class="fa fa-search"> Buscar</i>
										</button>
									</div>
								</div>
							</div>
							<hr>
							{% if not perms.tickets.can_see_other_ticket %}
								<div class="btn-group">
									{% get_ticket_close ticket_list as status_count%}
									{% for status in status_count%}
										{% if status.status__status == 'OPEN' %}
											<a type="button" class="btn btn-default" 
											{% if request.GET.last_status == 'OPEN' %}
												href="" disabled
											{% else %}
												href="{% url 'user_ticket' %}?last_status=OPEN"
											{% endif %}
											>{{ status.total }} Open</a>
										{% elif status.status__status == 'CLOSED' %}
											<a type="button" class="btn btn-default"  
											{% if request.GET.last_status == 'CLOSED' %}
												href="" disabled
											{% else %}
												href="{% url 'user_ticket' %}?last_status=CLOSED"
											{% endif %}
											>{{ status.total }} Closed</a>
										{% endif %}
									{% endfor %}
								</div>
							{% endif %}
							{% if request.GET %}
								<a href="{% url 'user_ticket' %}"> <i class="fa fa-times-circle" aria-hidden="true"></i> <strong>Limpiar filtros</strong></a>
							{% endif %}
							<!-- BEGIN NEW TICKET -->
							<button type="button" class="btn btn-success pull-right" data-toggle="modal"
								data-target="#newIssue">Nuevo ticket</button>
							<div class="modal fade" id="newIssue" tabindex="-1" role="dialog" aria-labelledby="newIssue" aria-hidden="true">
								<div class="modal-wrapper">
									<div class="modal-dialog">
										<form method="POST" id="createTicket" onsubmit="createTicket(this); return false;">
											<div class="modal-content">
												<div class="modal-header bg-blue">
													<button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
													<h4 class="modal-title"><i class="fa fa-pencil"></i> Crear nuevo ticket
													</h4>
													{{ user.first_name }}
												</div>
												<div class="form-group">
													<input type="text" id="createTicketIssue" name="issue" class="form-control" placeholder="Asunto"/>
													<select name="category" id="createTicketCategory" class="form-select" aria-label="Categorias" id="ticketCategories">
													</select>
													<textarea name="description" id="createTicketDescription" class="form-control" placeholder="Detalla tu problema o pregunta."
														style="height: 120px;"></textarea>
												</div>
												<div class="form-group">
													<input name="ticketAttached" type="file" name="attached">
												</div>
											</div>
											<div class="modal-footer">
												<button type="button" class="btn btn-default" data-dismiss="modal"><i class="fa fa-times"></i>
													Descartar</button>
												<button type="submit" class="btn btn-primary pull-right"><i class="fa fa-pencil" id="createTicketSubmit"></i>
													Crear</button>
											</div>
										</form>
									</div>
								</div>
							</div>
						</div>
						<!-- END NEW TICKET -->

						<div class="padding"></div>

						<div class="row">
							<!-- BEGIN TICKET CONTENT -->
							<div class="col-md-12">
								<ul class="list-group fa-padding">
									{% for ticket in page_obj %}
									<li class="list-group-item" data-toggle="modal" data-target="#issueModal" onclick="Ticketsearch('{{ ticket.id }}')">
										<div class="media">
											<i class="fa {% if ticket.category.icon %}{{ ticket.category.icon }} {% else %} fa fa-cog {% endif %} pull-left"></i>
											<div class="media-body">
												<strong>{{ ticket.issue }}</strong> <span class="label 
												{% if ticket.priority == 'LOW' %}
													label-primary
												{% elif ticket.priority == 'HIGH' %}
													label-danger
												{% else %}
													label-warning
												{% endif %}
													">
													{{ ticket.priority }}</span><span class="number pull-right"># 
														{{ ticket.id }}</span>
												<p class="info"> {{ ticket.status.first.get_status_display }} by <a href="#">{{ user.first_name }}</a> 
													{{ticket.create_at|date:"M/d" }} <i class="fa fa-comments"></i> <a
														href="#">{{ ticket.detail.count }} comments</a></p>
											</div>
										</div>
									</li>
									{% endfor %}
								</ul>

								<!-- BEGIN DETAIL TICKET -->
								<div class="modal fade" id="issueModal" tabindex="-1" role="dialog" aria-labelledby="issue"
									aria-hidden="true">
									<div class="modal-wrapper">
										<div class="modal-dialog">
											<div class="modal-content">
												<div class="modal-header bg-blue">
													<button type="button" class="close" data-dismiss="modal"
														aria-hidden="true">×</button>
													<h4 class="modal-title" id="ticketIssueDetailModal"><i class="fa fa-cog"></i> </h4>
												</div>
												<form action="#" method="post">
													<div class="modal-body">
														<div class="row">
															<div class="col-md-9">
																<p id="ticketSummaryDetailModal"></p>
															</div>
															{% if perms.tickets.can_see_other_ticket %}
																<div class="col-md-2">
																	<select id="selectStatus" class="form-select" onchange="changeStatus(this)">
																		<option value="IN_PROGRESS">En progreso</option>
																		<option value="OPEN">Abierto</option>
																		<option value="SUCCESS">Exitoso</option>
																		<option value="CLOSED">Cerrado</option>
																	</select>
																</div>
															{% endif %}
														</div>
														<div class="row support-content-comment" id="ticketDetailComments">
														</div>
													</div>
													<div class="modal-footer">
														<button type="button" class="btn btn-default"
															data-dismiss="modal"><i class="fa fa-times"></i>
															Close</button>
													</div>
												</form>
											</div>
										</div>
									</div>
								</div>
								<!-- END DETAIL TICKET -->
							</div>
							<!-- END TICKET CONTENT -->
							<div class="col-md-12">
								<nav aria-label="tickets navigation">
									<ul class="pagination justify-content-center">
										{% if page_obj.has_previous %}
										<li class="page-item">
											<a class="page-link"
												href="?page={{ page_obj.previous_page_number }}">Anterior</a>
										</li>
										{% else %}
										<li class="page-item disabled">
											<a class="page-link" href="#">Anterior</a>
										</li>
										{% endif %}
										{% for page in paginator.page_range%}
										<li class="page-item"><a class="page-link" href="?page={{ page }}">
											{{ page }}</a></li>
										{% endfor %}
										{% if page_obj.has_next %}
										<li class="page-item">
											<a class="page-link" href="?page={{ page_obj.next_page_number }}">Siguiente</a>
										</li>
										<!-- <a href="?page={{ page_obj.paginator.num_pages }}">last &raquo;</a> -->
										{% else %}
										<li class="page-item disabled">
											<a class="page-link" href="#">Siguiente</a>
										</li>
										{% endif %}
									</ul>
								</nav>
							</div>
						</div>
					</div>
				</div><!-- Modal -->
				<div class="modal fade" id="replyModal" tabindex="-1" role="dialog" aria-labelledby="replyModalLabel" aria-hidden="true">
					<div class="modal-dialog" role="document">
						<div class="modal-content">
							<div class="modal-header">
								<h5 class="modal-title" id="replyModalLabel">Comentario</h5>
								<button type="button" class="close" data-dismiss="modal" aria-label="Close">
								<span aria-hidden="true">&times;</span>
								</button>
							</div>
							<div class="modal-body">
								<div class="form-group">
									<input type="text" id="ticketIdComment" hidden>
									<textarea id="ticketDescriptionComment" class="form-control" placeholder="Escriba su comentario ... "
										style="height: 120px;"></textarea>
								</br>
									<input name="ticketAttachedComment" type="file" name="attached">
								</div>
							</div>
							<div class="modal-footer">
								<button type="button" class="btn btn-primary" onclick="replyModal(this)"><i class="fa fa-pencil" id="CommentTicket"></i>Enviar</button>
							</div>
						</div>
					</div>
				</div>
			</div>
			<!-- END TICKET -->
	</div>
	</section>
	</div>

	<script type="text/javascript">
		window.onload = function(){
			let select = document.getElementById("createTicketCategory") 	
			fetch("{% url 'category-list' %}", 
				{
					method: 'GET', 
					headers:
					{'Content-Type': 'application/json'}
				}
				)
				.then(response => response.json())
				.then(data => data.forEach(element => {
					let opt = document.createElement('option');
					opt.value = element.id;
					opt.innerHTML = element.name;
					select.appendChild(opt);
					}
				));
		}
		const createTicket = (button) => {
			button.disabled = true
			let createTicketSubmit = document.getElementById("createTicketSubmit") 
			createTicketSubmit.className = "fa fa-spinner fa-spin"
			let select = document.getElementById("createTicketCategory") 
			let inputFile = document.querySelector('input[name="ticketAttached"]')	
			ticketData = {
				issue: document.getElementById("createTicketIssue").value,
				detail:[{description: document.getElementById("createTicketDescription").value}],
				category: select.options[select.selectedIndex].value,
			}
			postData("{% url 'ticket-list' %}", JSON.stringify(ticketData))
				.then(response => {
					if(response.ok){						
						button.disabled = false
						if (!inputFile.files.length > 0){
								location.reload();
						}
					}
					return response
				})
				.then(response => response.json())
				.then(data => {
    				if (inputFile.files.length > 0){
						attached = inputFile.files[0]
						detailId = data.detail[0].id

						const formData  = new FormData()
						jQuery.each(attached, function(i, file) {
							formData.append('attached', attached);
						});
						jQuery.ajax({
							url: `{% url 'ticket_comment-list' %}${detailId}/`,
							data: formData,
							headers: {
								'X-CSRFToken': '{{ csrf_token }}'
							},
							cache: false,
							contentType: false,
							processData: false,
							method: 'PATCH',
							success: function(data){
								location.reload();
							}
						});
					}
  				})
		}

		async function postData(url, data, contentType = 'application/json', method='POST') {
			const response = await fetch(url, {
				method: method,
				headers: {
				'Content-Type': contentType,
				'X-CSRFToken': '{{ csrf_token }}'
				},
				body: data,
			});
			return response;
		}
		
		const Ticketsearch = (ticketId) => {
			fetch(`{% url 'ticket-list' %}${ticketId}/`, 
				{
					method: 'GET', 
					headers:
					{'Content-Type': 'application/json'}
				}
				)
				.then(response => response.json())
				.then(data => {
					let ticketIssueDetailModal = document.getElementById("ticketIssueDetailModal")
					ticketIssueDetailModal.textContent = data.issue
					
					let dateCreateTicket = new Date(data.create_at)
					let ticketSummaryDetailModal = document.getElementById("ticketSummaryDetailModal")
					ticketSummaryDetailModal.innerHTML = `Ticket <strong>#${data.id}</strong> ${data.last_status} by <a href="#">${data.client_name}</a> 
														   ${dateCreateTicket.getDate()}/${dateCreateTicket.getMonth()}/${dateCreateTicket.getFullYear()}`
					ticketDetailComments = document.getElementById("ticketDetailComments")
					ticketDetailComments.innerHTML = ''
					data.detail.forEach(
						(item, index) => {
							// ticketDetailComments.innerHTML += `<div>`
							iconUserOp = 'https://img2.freepng.es/20181126/jkq/kisspng-know-your-customer-computer-icons-drive-innovation-5bfbc37f0e7420.3222611815432262390592.jpg'
							let dateDetailTicket = new Date(item.create_at)
							if (item.employee != null){
								iconUserOp = 'https://www.seekpng.com/png/detail/242-2420403_atencin-al-cliente-thief-icon-png.png'
							}
							ticketDetailComments.innerHTML += `<div class="col-md-2"><img src="${iconUserOp}" class="img-circle" alt="" width="40"></div>`
							ticketDetailComments.innerHTML += `<p>${dateDetailTicket.getDate()}/${dateDetailTicket.getMonth()}/${dateDetailTicket.getFullYear()} ${dateCreateTicket.getHours()}:${dateCreateTicket.getMinutes()}</p>
																<p>${item.description}</p>`
							if (item.attached != null){
								ticketDetailComments.innerHTML += `<p><a href="${item.attached}">Archivo adjunto</a></p>`
							}
							if(index == 0){
								ticketDetailComments.innerHTML += `<button type="button" data-toggle="modal" data-target="#replyModal" ><span class="fa fa-reply"></span> &nbsp; Post
																	a reply</button>`
							}
							ticketDetailComments.innerHTML += `<hr style="border: 2px solid white">`
							let ticketIdComment = document.getElementById("ticketIdComment")
							ticketIdComment.text = ticketId
						}
					)					
					
				});
		}
		
		const replyModal = (button) => {
			button.disabled = true
			let commentTicket = document.getElementById("CommentTicket") 
			commentTicket.className = "fa fa-spinner fa-spin"
			let ticketIdComment = document.getElementById("ticketIdComment")
			let ticketDescriptionComment = document.getElementById("ticketDescriptionComment")
			let ticketId = parseInt(ticketIdComment.text, 10)
			let inputFile = document.querySelector('input[name="ticketAttachedComment"]')
			const formData  = new FormData()
			if (inputFile.files.length > 0){
					attached = inputFile.files[0]
					jQuery.each(attached, function(i, file) {
						formData.append('attached', attached);
					});
					
			}
			formData.append("description", ticketDescriptionComment.value)
			formData.append("ticket", ticketId)
			jQuery.ajax({
					url: `{% url 'ticket_comment-list' %}`,
					data: formData,
					headers: {
						'X-CSRFToken': '{{ csrf_token }}'
					},
					cache: false,
					contentType: false,
					processData: false,
					method: 'POST',
					success: function(data){
						location.reload();
					}
				});
		}

		const changeStatus = (button) => {
			let ticketIdComment = document.getElementById("ticketIdComment")
			let ticketId = parseInt(ticketIdComment.text, 10)
			let e = document.getElementById("selectStatus");
			let status = e.value;
			ticketStatusData = {
				status: status,
				ticket: ticketId
			}
			postData("{% url 'ticket_status-list' %}", JSON.stringify(ticketStatusData))
			.then(response => {
					if(response.ok){						
						location.reload();
					}
					return response
				})
		}
	</script>
</body>

</html>